Index: /ssp_qb_r5f100le_cs/trunk/arch/rl78_ca78k0r/prc_support.asm
===================================================================
--- /ssp_qb_r5f100le_cs/trunk/arch/rl78_ca78k0r/prc_support.asm	(revision 94)
+++ /ssp_qb_r5f100le_cs/trunk/arch/rl78_ca78k0r/prc_support.asm	(revision 95)
@@ -6,81 +6,77 @@
 ;             Nagoya Municipal Industrial Research Institute, JAPAN
 ; 
-;  ãLì ÒÍCÈºÌ (1)`(4) Ìðð½·êÉÀèC{\tgEF
-;  Ai{\tgEFAðüÏµ½àÌðÜÞDÈº¯¶jðgpE¡»EüÏE
-;  ÄzziÈºCpÆÄÔj·é±Æð³Åø·éD
-;  (1) {\tgEFAð\[XR[hÌ`Åp·éêÉÍCãLÌì 
-;      \¦C±Ìpð¨æÑºLÌ³ÛØKèªC»ÌÜÜÌ`Å\[X
-;      R[hÉÜÜêÄ¢é±ÆD
-;  (2) {\tgEFAðCCu`®ÈÇC¼Ì\tgEFAJ­Égp
-;      Å«é`ÅÄzz·éêÉÍCÄzzÉº¤hL
-gipÒ}
-;      j
-AÈÇjÉCãLÌì \¦C±Ìpð¨æÑºLÌ³Û
-;      ØKèðfÚ·é±ÆD
-;  (3) {\tgEFAðC@íÉgÝÞÈÇC¼Ì\tgEFAJ­Égp
-;      Å«È¢`ÅÄzz·éêÉÍCÌ¢¸ê©Ìðð½·±ÆD
-;    (a) ÄzzÉº¤hL
-gipÒ}j
-AÈÇjÉCãLÌì
-;         \¦C±Ìpð¨æÑºLÌ³ÛØKèðfÚ·é±ÆD
-;    (b) ÄzzÌ`ÔðCÊÉèßéû@ÉæÁÄCTOPPERSvWFNgÉñ
-;        ·é±ÆD
-;  (4) {\tgEFAÌpÉæè¼ÚIÜ½ÍÔÚIÉ¶¶é¢©Èé¹Q
-;      ©çàCãLì Ò¨æÑTOPPERSvWFNgðÆÓ·é±ÆDÜ½C
-;      {\tgEFAÌ[UÜ½ÍGh[U©çÌ¢©ÈéRÉîÃ
-;      ­¿©çàCãLì Ò¨æÑTOPPERSvWFNgðÆÓ·é±ÆD
-; 
-;  {\tgEFAÍC³ÛØÅñ³êÄ¢éàÌÅ éDãLì Ò¨æ
-;  ÑTOPPERSvWFNgÍC{\tgEFAÉÖµÄCÁèÌgpÚIÉÎ·
-;  éK«àÜßÄC¢©ÈéÛØàsíÈ¢DÜ½C{\tgEFAÌp
-;  Éæè¼ÚIÜ½ÍÔÚIÉ¶¶½¢©Èé¹QÉÖµÄàC»ÌÓCð
-;  íÈ¢D
-; 
-; 
-
-;
-;  J[lÀÌvZbTË¶ª
-;
-
-;
-;  }Nè`ÌCN[h
+;  上記著作権者は，以下の (1)〜(4) の条件を満たす場合に限り，本ソフトウェ
+;  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改変・
+;  再配布（以下，利用と呼ぶ）することを無償で許諾する．
+;  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作権
+;      表示，この利用条件および下記の無保証規定が，そのままの形でソース
+;      コード中に含まれていること．
+;  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使用
+;      できる形で再配布する場合には，再配布に伴うドキュメント（利用者マ
+;      ニュアルなど）に，上記の著作権表示，この利用条件および下記の無保
+;      証規定を掲載すること．
+;  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使用
+;      できない形で再配布する場合には，次のいずれかの条件を満たすこと．
+;    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著作
+;        権表示，この利用条件および下記の無保証規定を掲載すること．
+;    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに報
+;        告すること．
+;  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損害
+;      からも，上記著作権者およびTOPPERSプロジェクトを免責すること．また，
+;      本ソフトウェアのユーザまたはエンドユーザからのいかなる理由に基づ
+;      く請求からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+; 
+;  本ソフトウェアは，無保証で提供されているものである．上記著作権者およ
+;  びTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的に対す
+;  る適合性も含めて，いかなる保証も行わない．また，本ソフトウェアの利用
+;  により直接的または間接的に生じたいかなる損害に関しても，その責任を負
+;  わない．
+; 
+; 
+
+;
+;  カーネル実装のプロセッサ依存部分
+;
+
+;
+;  マクロ定義のインクルード
 ;
 $INCLUDE(prc_support_def.inc)
 
 ;
-;  O[oV{
-;
-	; RpCªgp·é saddrÌæÌWX^
+;  グローバルシンボル
+;
+	; コンパイラが使用する saddr領域のレジスタ
 	extrn	_@RTARG0,_@RTARG2,_@RTARG4,_@RTARG6,_@SEGAX,_@SEGDE
 	extrn	_@NRARG0,_@NRARG1,_@NRARG2,_@NRARG3
 	extrn	_@NRAT00,_@NRAT02,_@NRAT04,_@NRAT06
 	; kernel_cfg.c
-	extrn	__kernel_istkpt     	; X^bN|C^Ìúl
+	extrn	__kernel_istkpt     	; スタックポインタの初期値
 	; prc_config.c
-	extrn	_t_lock_cpu         	; CPUbNóÔÖÌÚs
-	extrn	__kernel_intnest    	; ÝÌlXgJE^
-	extrn	__kernel_lock_flag  	; CPUbNtO
+	extrn	_t_lock_cpu         	; CPUロック状態への移行
+	extrn	__kernel_intnest    	; 割込みのネストカウンタ
+	extrn	__kernel_lock_flag  	; CPUロックフラグ
 	; task.c
-	extrn	__kernel_dispatcher 	; fBXpb`
-	extrn	__kernel_reqflg     	; fBXpb`vtO
-	extrn	__kernel_disdsp     	; fBXpb`Ö~óÔ
-	extrn	__kernel_search_schedtsk	; ÅDæxÌT[`
-	extrn	__kernel_run_task   	; ^XNÌJn
+	extrn	__kernel_dispatcher 	; ディスパッチャ
+	extrn	__kernel_reqflg     	; ディスパッチ要求フラグ
+	extrn	__kernel_disdsp     	; ディスパッチ禁止状態
+	extrn	__kernel_search_schedtsk	; 最高優先度のサーチ
+	extrn	__kernel_run_task   	; タスクの開始
 	; startup.c
-	extrn	__kernel_exit_kernel	; J[lÌI¹
+	extrn	__kernel_exit_kernel	; カーネルの終了処理
 
 	; prc_support.asm
-	public	__kernel_start_dispatch  	; fBXpb`ÌJn
-	public	__kernel_call_exit_kernel	; I¹ÌR[
-	public	__kernel_interrupt_entry 	; ÝÌüû(¤Ê)
-	public	__kernel_int_return      	; WX^ðAµÄÝ­¶³Ö^[
-	public	_unused_interrupt        	; ¢gpÝÌ
-
-;
-; RpCÅgp·ésaddrÌæÌWX^ðÛ¶
+	public	__kernel_start_dispatch  	; ディスパッチの開始処理
+	public	__kernel_call_exit_kernel	; 終了処理のコール
+	public	__kernel_interrupt_entry 	; 割込みの入口処理(共通部)
+	public	__kernel_int_return      	; レジスタを復帰して割込み発生元へリターン
+	public	_unused_interrupt        	; 未使用割込みの処理
+
+;
+; コンパイラで使用するsaddr領域のレジスタを保存
 ;
 restore_saddr_regs	macro
-$if (ALLOC_REGVAR_TO_SADDR) ; -qr IvVðgp·éê 
-	pop	ax           	; WX^A 
+$if (ALLOC_REGVAR_TO_SADDR) ; -qr オプションを使用する場合 
+	pop	ax           	; レジスタ復帰 
 	movw	_@NRAT06, ax  	; 
 	pop	ax           	; 
@@ -99,5 +95,5 @@
 	movw	_@NRARG0, ax  	; 
 $endif 
-	pop	ax           	; WX^A 
+	pop	ax           	; レジスタ復帰 
 	movw	_@SEGDE, ax  	; 
 	pop	ax           	; 
@@ -114,5 +110,5 @@
 
 ;
-;  X^bN|C^ðú»
+;  スタックポインタを初期化
 ;
 reset_sp	macro
@@ -124,5 +120,5 @@
 	
 ;
-;  PSW Ì ISP1 = 1, ISP0 = 1 ÉµÄÝÌ}XNðð·é
+;  PSW の ISP1 = 1, ISP0 = 1 にして割込みのマスクを解除する
 ;
 clear_pswisp_mask	macro
@@ -136,11 +132,11 @@
 
 ;
-;  J[lÌ®ìJnÉKvÆ³êéãnðs¤½ßÌÖ
-;  sta_ker(startup.c) ©çÄÑo³êéD
+;  カーネルの動作開始に必要とされる後始末を行うための関数
+;  sta_ker(startup.c) から呼び出される．
 ;
 __kernel_start_dispatch:
 	;
-	;  CPUbNóÔÆSÝbNóÔÆðæÊ·éKvª éêC
-	;  CPUbNóÔÉµCSÝbNÌóÔðð·éD
+	;  CPUロック状態と全割込みロック状態とを区別する必要がある場合，
+	;  CPUロック状態にし，全割込みロック相当の状態を解除する．
 	;
 	call !!_t_lock_cpu
@@ -151,21 +147,21 @@
 $ENDIF
 	;
-	;  X^bN|C^ðú»·é
-	;  sta_ker ©ç start_dispatch ÌÖR[ÉæéX^bNÁïªð
-	;  NA·é½ßCX^bN|C^ðú»·éD
+	;  スタックポインタを初期化する
+	;  sta_ker から start_dispatch の関数コールによるスタック消費分を
+	;  クリアするため，スタックポインタを初期化する．
 	;
 	reset_sp
 
 	;
-	;  dispatcher (task.c) ÖWv·é
-	;  ÖR[ÉµÈ¢ÌÍX^bNðßñ·é½ßD
-	;
-	; dispatcher (kernel/task.c) ÌÄÑoµ
+	;  dispatcher (task.c) へジャンプする
+	;  関数コールにしないのはスタックを節約するため．
+	;
+	; dispatcher (kernel/task.c) の呼び出し
 	br	!!__kernel_dispatcher
 
 
 ;
-;  I¹ÌÄÑoµ
-;  X^bN|C^ðú»µCexit_kernel ðÄÑo·D
+;  終了処理の呼び出し
+;  スタックポインタを初期化し，exit_kernel を呼び出す．
 ;
  __kernel_call_exit_kernel:
@@ -177,40 +173,40 @@
 
 ;
-;  Ý/CPUáOÌoüû(¤Ê)
-;    J[lÇÌÝÜ½ÍCPUáOÌêÉWX^Û¶ãCÄÑo³êéD
-;
-;   Oñð
-;	EPSWWX^ÌIErbg=0, ISPÍót¯½ÝÌISP.
-;	EnhÌAhXª bc Éi[³êÄ¢é.
-;   ECPUáOnhÌüû©ç½êCX^bN|C^Ì
-;     æªÔn(p_excinf)ª ax Éi[³êÄ¨èC
-;     ±êÍCPUáOnhÌø(p_excinf)ÆµÄ»ÌÜÜn³êéD
-;
-;	WX^ªX^bNãÉÇÌæ¤ÉÛ¶³êÄ¢é©ðÈºÉ¦·.
-;	}ÍÀÑÌÝð\»µ½àÌÅ èCTCYðl¶µÄ¢È¢±ÆÉÓ·éD
-;	³mÉÍf[^V[gðQÆÌ±ÆD
-;	±Ì}ÅÍãªáÊ, ºªÊÌAhXÅ, X^bNÍ}Ìº¤©ç
-;	ãûüÉü©ÁÄÏÝã°çêéàÌÆ·é.
-;
-;	¦1 saddrÌæÌ[NGAÍRpCIvV -qr ðwè·éêÉ
-;       Û¶ªKvÅ èCÊíÍÛ¶µÈ¢DÛ¶·éêÍAZuIvV
-;       ÉÄuALLOC_REGVAR_TO_SADDRvðè`·é±ÆD
-;
-;	¦2 CPUáOÌüûðoRµ½êÌÝÛ¶³êé
-;
-;
-;	---------------<-- p_excinf(¦)
-;	|  saddrÌæ   |
-;	|[NpGA|
-;	|  (16byte)¦1 |
+;  割込み/CPU例外の出入口処理(共通部)
+;    カーネル管理の割込みまたはCPU例外の場合にレジスタ保存後，呼び出される．
+;
+;   前提条件
+;	・PSWレジスタのIEビット=0, ISPは受付けた割込みのISP.
+;	・ハンドラのアドレスが bc に格納されている.
+;   ・CPU例外ハンドラの入口から来た場合，スタックポインタの
+;     先頭番地(p_excinf)が ax に格納されており，
+;     これはCPU例外ハンドラの引数(p_excinf)としてそのまま渡される．
+;
+;	レジスタがスタック上にどのように保存されているかを以下に示す.
+;	図は並び順のみを表現したものであり，サイズを考慮していないことに注意する．
+;	正確にはデータシートを参照のこと．
+;	この図では上が低位, 下が高位のアドレスで, スタックは図の下側から
+;	上方向に向かって積み上げられるものとする.
+;
+;	※1 saddr領域のワークエリアはコンパイラオプション -qr を指定する場合に
+;       保存が必要であり，通常は保存しない．保存する場合はアセンブラオプション
+;       にて「ALLOC_REGVAR_TO_SADDR」を定義すること．
+;
+;	※2 CPU例外の入口を経由した場合のみ保存される
+;
+;
+;	---------------<-- p_excinf(※)
+;	|  saddr領域   |
+;	|ワーク用エリア|
+;	|  (16byte)※1 |
 ;	---------------<-- p_excinf
-;	|  saddrÌæ   |
-;	|ZOgîñ|
-;	| i[pGA |
+;	|  saddr領域   |
+;	|セグメント情報|
+;	| 格納用エリア |
 ;	|   (4byte)    |
 ;	---------------
-;	|  saddrÌæ   |
-;	|  ^C  |
-;	|  øGA  |
+;	|  saddr領域   |
+;	|  ランタイム  |
+;	|  引数エリア  |
 ;	|   (8byte)    |
 ;	---------------
@@ -230,34 +226,34 @@
 ;	---------------
 ;
-;	nh©ç^[µ½ãÍ, ½dÝÅÈ­, ©ÂC
-;	reqflg ª TRUEC©ÂCdisdsp ª FALSE ÌÉCinterrupt_dispatch Öªò·éD
-;
-;	½dÝ©Ç¤©ÍÝlXgJE^ÌlÅ»è·é.
-;	intnest > 0 ÈçÎ½dÝÅ éÆ»è·é.
+;	ハンドラからリターンした後は, 多重割込みでなく, かつ，
+;	reqflg が TRUE，かつ，disdsp が FALSE の時に，interrupt_dispatch へ分岐する．
+;
+;	多重割込みかどうかは割込みネストカウンタの値で判定する.
+;	intnest > 0 ならば多重割込みであると判定する.
 ;
 
 __kernel_interrupt_entry:
-	inc 	!__kernel_intnest   	; lXgJE^ðCNg
-	ei  	                    	; ÝÂ(IPLÍó¯t¯çê½ÝÌx)
-	call	bc                  	; ÝnhÄÑoµ
-	di  	                    	; ÝÖ~
-	dec 	!__kernel_intnest   	; lXgJE^ðfNg
-	bnz 	$__kernel_int_return 	; ßèæªñ^XNReLXg(ñ[)ÈçPÉ^[
-	movw	ax,!__kernel_reqflg  	; fBXpb`vª é©Ç¤©
+	inc 	!__kernel_intnest   	; ネストカウンタをインクリメント
+	ei  	                    	; 割込み許可(IPLは受け付けられた割込みのレベル)
+	call	bc                  	; 割込みハンドラ呼び出し
+	di  	                    	; 割込み禁止
+	dec 	!__kernel_intnest   	; ネストカウンタをデクリメント
+	bnz 	$__kernel_int_return 	; 戻り先が非タスクコンテキスト(非ゼロ)なら単にリターン
+	movw	ax,!__kernel_reqflg  	; ディスパッチ要求があるかどうか
 	cmpw	ax, #0
-	bz  	$__kernel_int_return 	; È¯êÎCPÉ^[
+	bz  	$__kernel_int_return 	; なければ，単にリターン
 	movw	ax, #0
-	movw	!__kernel_reqflg, ax 	; reqflg = FALSE ÉßµÄ¨­
-	movw	ax, !__kernel_disdsp 	; fBXpb`Ö~©Ç¤©
+	movw	!__kernel_reqflg, ax 	; reqflg = FALSE に戻しておく
+	movw	ax, !__kernel_disdsp 	; ディスパッチ禁止かどうか
 	cmpw	ax, #0
-	bnz 	$__kernel_int_return 	; Ö~ÈçCPÉ^[
-
-;
-;  ÝÌoû(fBXpb`t«)
-;    CPU bNÌóÔÉÚsµCVK^XNðJn·é
-;
-;  OñðF
-;    PSWWX^ÌIEtO = 0 (ÝÖ~)
-;    PSWWX^ÌISP{1,0} = ó¯t¯½ÝÌÝx
+	bnz 	$__kernel_int_return 	; 禁止なら，単にリターン
+
+;
+;  割込みの出口処理(ディスパッチ付き)
+;    CPU ロック相当の状態に移行し，新規タスクを開始する
+;
+;  前提条件：
+;    PSWレジスタのIEフラグ = 0 (割込み禁止)
+;    PSWレジスタのISP{1,0} = 受け付けた割込みの割込みレベル
 ;
 __kernel_interrupt_dispatch:
@@ -272,20 +268,20 @@
 	call	!!__kernel_run_task
 
-	; run_task ©çÌ^[ãÌóÔ: CPUbNóÔ
-	; __kernel_int_return Ì reti Å PSW Ì IE, ISP Í
-	; Ý­¶OÌóÔÉßé½ßClock_flag ¾¯³Éß·D
+	; run_task からのリターン後の状態: CPUロック状態
+	; __kernel_int_return の reti で PSW の IE, ISP は
+	; 割込み発生前の状態に戻るため，lock_flag だけ元に戻す．
 	movw	ax, #0
-	movw	!__kernel_lock_flag, ax 	; lock_flag ðNA
-
-;
-;  WX^AµÄÝ©ç^[
+	movw	!__kernel_lock_flag, ax 	; lock_flag をクリア
+
+;
+;  レジスタ復帰して割込みからリターン
 ;
 __kernel_int_return:
-	restore_saddr_regs	; saddrÌæÌWX^A
-	pop 	ax          ; ES, CS ÌA 
+	restore_saddr_regs	; saddr領域のレジスタ復帰
+	pop 	ax          ; ES, CS の復帰 
 	mov 	cs, a       ; 
 	mov 	a, x        ; 
 	mov 	es, a       ; 
-	pop 	hl          ; WX^ðA 
+	pop 	hl          ; レジスタを復帰 
 	pop 	de
 	pop 	bc
@@ -294,5 +290,5 @@
 
 ;
-;  ³À[v(OÌ½ß)
+;  無限ループ(念のため)
 ;
 _loop:
@@ -300,5 +296,5 @@
 
 ;
-;  ¢gpÝ
+;  未使用割込み
 ;
 _unused_interrupt:
